# This tasklist is called by configure_backups.yml.
#
# Functionality: 
#   Create s3 bucket for `bucket`
#   Create Velero storage location for this bucket. 
#   Create 4hr schedule for the `backup_namespace` if `create_schedule`
#   Remove scehedule if not `create_schedule`

- name: Create backup bucket
  s3_bucket:
    name: "{{ bucket }}"
    state: present
    s3_url: "https://{{ s3_url }}"
    aws_access_key: "{{ secret_data.get(site_name + '.accesskey') | b64decode }}"
    aws_secret_key: "{{ secret_data.get(site_name + '.secretkey') | b64decode }}"
 
- name: Create velero storage location
  k8s:
    state: present
    wait: true
    definition:
      apiVersion: velero.io/v1
      kind: BackupStorageLocation
      metadata:
        name: "{{ storagelocation }}"
        namespace: "{{ config.velero.namespace }}"
      spec:
        provider: velero.io/aws
        objectStorage:  
          bucket: "{{ bucket }}"
        config:
          region: "minio"
          s3Url: "https://{{ s3_url }}"
          s3ForcePathStyle: "true"
          profile: "{{ site_name }}"
        accessMode: ReadWrite
        
- name: Create Schedule
  include_tasks: "create_schedule.yml"
  when: create_schedule | default(true)
 
- name: Remove Backup schedule 
  k8s:
    kind: Schedule
    api_version: v1
    namespace: "{{ config.velero.namespace }}"
    name: "{{ site_name }}-{{ config.system.cluster_name }}-{{ backup_namespace }}-every4h"
    state: absent
  when: create_schedule | default(true) == false